﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Interactivity;
using Infragistics.Windows.Editors;
using Infragistics.Windows;
using System.Collections.Specialized;
//using Infragistics.Windows.DataPresenter;
using System.Windows.Input;
using System.Windows.Controls;
using System.Windows;
using System.Windows.Data;
//using System.Windows.Controls;
using System.ComponentModel;
using System.Collections;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace XamComboEditorMVVMBeh
{
    /// <summary>

    /// ////////////////////////////////////////////////////////////////////////////////////////////////////

    /// </summary>
    public class XamComboEditor1Behavior : Behavior<XamComboEditor>
    {
        private bool _surpressSelectedValuePropertyChangedCallback;
        private bool _surpressSelectedValueUpdate;

        #region Properties

        //public static readonly DependencyProperty ItemsSourceProperty = DependencyProperty.Register("ItemsSource", typeof(IEnumerable), typeof(XamComboEditor1Behavior), new UIPropertyMetadata(null, new PropertyChangedCallback(OnItemsSourceChanged)));

        public static readonly DependencyProperty ItemsSourceProperty =
            DependencyProperty.Register(
                "ItemsSource",
                typeof(IEnumerable),
                typeof(XamComboEditor1Behavior),
                new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, OnItemsSourceChanged));

        public IEnumerable ItemsSource
        {
            get { return (IEnumerable)GetValue(ItemsSourceProperty); }
            set { SetValue(ItemsSourceProperty, value); }
        }

        private static void OnItemsSourceChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            XamComboEditor1Behavior bahavior = o as XamComboEditor1Behavior;
            if (bahavior != null)
                bahavior.OnItemsSourceChanged((IEnumerable)e.OldValue, (IEnumerable)e.NewValue);
        }

        private void OnItemsSourceChanged(IEnumerable oldvalue, IEnumerable newValue)
        {
            if (newValue != null)
            {
                _surpressSelectedValuePropertyChangedCallback = true;

                //GetInitiallySelectedItems();

                UpdateSelectedValue();

                _surpressSelectedValuePropertyChangedCallback = false;
            }
        }

        public static readonly DependencyProperty SelectedValueProperty =
            DependencyProperty.Register(
                "SelectedValue",
                typeof(string),
                typeof(XamComboEditor1Behavior),
                new FrameworkPropertyMetadata(null, FrameworkPropertyMetadataOptions.BindsTwoWayByDefault, OnSelectedValueChanged));

        public string SelectedValue
        {
            get { return (string)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }

        private static void OnSelectedValueChanged(DependencyObject o, DependencyPropertyChangedEventArgs e)
        {
            XamComboEditor1Behavior bahavior = o as XamComboEditor1Behavior;
            if (bahavior != null)
            {
                bahavior.OnSelectedValueChanged((string)e.OldValue, (string)e.NewValue);
            }
        }

        protected virtual void OnSelectedValueChanged(string oldValue, string newValue)
        {
            if (_surpressSelectedValuePropertyChangedCallback)
                return;

            UpdateSelectedItemsFromSelectedValue();
        }

        #endregion //Properties

        #region Base Class Overrides

        protected override void OnAttached()
        {
            base.OnAttached();

            Binding binding = new Binding("ItemsSource");
            binding.Source = AssociatedObject;
            BindingOperations.SetBinding(this, XamComboEditor1Behavior.ItemsSourceProperty, binding);

            AssociatedObject.PreviewKeyDown += AssociatedObject_PreviewKeyDown;
            AssociatedObject.SelectedItemChanged += AssociatedObject_SelectionChanged;
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();

            BindingOperations.ClearBinding(this, XamComboEditor1Behavior.ItemsSourceProperty);
            AssociatedObject.PreviewKeyDown -= AssociatedObject_PreviewKeyDown;
            AssociatedObject.SelectedItemChanged -= AssociatedObject_SelectionChanged;
        }

        #endregion //Base Class Overrides

        #region Event Handlers

        void AssociatedObject_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            Application.Current.Dispatcher.BeginInvoke(
                DispatcherPriority.Background,
                new Action(() =>
                {
                    var editor = sender as XamComboEditor;                    
                    string text = editor.Text;       
                }));

            if (ItemsSource == null)
                return;

            List<MyComboBoxItem> tempList = new List<MyComboBoxItem>();

            if (e.Key != Key.Back && e.Key != Key.Delete && e.Key != Key.Down && e.Key != Key.Up && e.Key != Key.Enter && e.Key != Key.LeftShift)
            {
                TextBox ttb = Utilities.GetDescendantFromName(sender as DependencyObject, "PART_EditableTextBox") as TextBox;

                if (ttb != null)
                {
                    (sender as XamComboEditor).IsDropDownOpen = true;

                    //(sender as XamComboEditor).Style.TargetType = typeof(System.Windows.Controls.ComboBox);
                    //Dispatcher.BeginInvoke(new Action(() =>
                    //{
                    //ComboBoxItemsProvider cp = CB.ItemsProvider;
                    //List<string> tempList = new List<string>();

                    ComboBoxItemsProvider cp = AssociatedObject.ItemsProvider;

                    foreach (MyComboBoxItem item in cp.Items)
                    {
                        string item1;
                        int ind = item.Name.IndexOf('~');
                        //if (ind == -1)
                        //{ 
                            item1 = item.Name; 
                        //}
                        //else
                        //{ 
                        //    item1 = item.Description(); 
                        //}

                        if (item1.ToLowerInvariant().StartsWith(e.Key.ToString().ToLowerInvariant()))
                        {
                            tempList.Add(item);
                        }
                    }

                    if (tempList.Count > 0)
                    {
                        //(sender as XamComboEditor).ItemsSource = new ObservableCollection<MyComboBoxItem>(tempList);
                        (sender as XamComboEditor).ItemsSource = tempList;                        
                    }

                    //else
                    //{
                    //    (sender as XamComboEditor).ItemsSource = vm.GlueCodeList;
                    //}
                    //}), System.Windows.Threading.DispatcherPriority.Background, null);
                }
            }
        }

        void AssociatedObject_SelectionChanged(object sender, EventArgs e)
        {
            if (_surpressSelectedValuePropertyChangedCallback)
                return;

            //update the selected value string but only if we are not surpressing the operation.

            if (!_surpressSelectedValueUpdate)
                UpdateSelectedValue();
        }

        #endregion //Event Handlers

        #region Methods

        protected object ResolveItemByValue(string value)
        {
            //if (!String.IsNullOrEmpty(ValueMemberPath))
            //{

            if (ItemsSource != null)
            {
                string selName = GetItemName(value);
                foreach (object item in ItemsSource)
                {
                    string Name = GetItemName(item.ToString());

                    //var property = item.GetType().GetProperty(ValueMemberPath);
                    //if (property != null)
                    //{
                    //    var propertyValue = property.GetValue(item, null);
                    //    if (value.Equals(propertyValue.ToString(), StringComparison.InvariantCultureIgnoreCase))
                    //        return item;
                    //}

                    if (Name.Equals(selName))
                        return item;
                }
            }

            //}

            return value;
        }

        private void UpdateSelectedItemsFromSelectedValue()
        {
            if (AssociatedObject == null)
                return;

            _surpressSelectedValueUpdate = true;

            //ClearSelectedItems();

            if (!String.IsNullOrEmpty(SelectedValue))
            {
                var item = ResolveItemByValue(SelectedValue.ToString());
                if (item != null)
                    AssociatedObject.SelectedItem = item;
            }

            _surpressSelectedValueUpdate = false;
        }

        private void UpdateSelectedValue()
        {
            if (AssociatedObject == null)
                return;

            _surpressSelectedValuePropertyChangedCallback = true;

            string newValue = "";

            if (AssociatedObject.SelectedItem != null)
            {
                newValue = AssociatedObject.SelectedItem.ToString();
            }

            if (String.IsNullOrEmpty(SelectedValue) || !SelectedValue.Equals(newValue))
                SelectedValue = newValue;

            _surpressSelectedValuePropertyChangedCallback = false;
        }

        public string GetItemName(string MyComboBoxItemString)
        {
            if (MyComboBoxItemString == null) 
            { 
                return ""; 
            }

            int ind = MyComboBoxItemString.IndexOf('~');
            if (ind == -1)
            { 
                return ""; 
            }
            else
            { 
                return MyComboBoxItemString.Substring(0, ind); 
            }
        }

        public string GetItemValue(string MyComboBoxItemString)
        {
            if (MyComboBoxItemString == null) 
            { 
                return ""; 
            }

            int ind = MyComboBoxItemString.IndexOf('~');
            if (ind == -1)
            { 
                return ""; 
            }
            else
            { 
                return MyComboBoxItemString.Substring(ind + 1, MyComboBoxItemString.Length - ind - 1); 
            }
        }

        #endregion //Methods
    }
}
